DEFINT A-Z

'IDhdr="EVNM" 'Block Contains a list of event names
'IDhdr-"PRNM" 'Block Contains a list of Person names
'IDhdr="EVST" Event sets the persons conversation no matter what
'IDhdr="EVRE" Event sets the persons conversation based on previous
'             conversation RE = Replace
'IDhdr="STRN" Block contains strings
'IDhdr="STAR" Block contains pointers to strings
'IDhdr="MEVN" Block contains a multievent equation
'IDhdr=MKL$(0) 'unallocated


TYPE ConversationBlockType
    IDhdr AS STRING * 4
    Length AS LONG
END TYPE


TYPE PersonStringType
  Person AS LONG
  Speech AS LONG
END TYPE

DECLARE FUNCTION EndOfFile& (FileHandle%)

DECLARE FUNCTION STRNgetMulti$ (StringNum&)
DECLARE FUNCTION STARMultiStringget$ (StringNum&)
DECLARE FUNCTION GetConversation$ (Person&, StringNum&)


DECLARE SUB FileSetPos (FileHandle%, fpos&)
DECLARE FUNCTION String0System$ (Person&)
DECLARE FUNCTION FileGetPos& (FileHandle%)
COMMON SHARED /ConverseFile/ ConverseFilename$, ConverseFileHandle%
DIM SHARED Speech&(0 TO PeopleCount&) 'Points to arrays
                               'Containing what people currently have to say
DIM SHARED SpeechEventStarted&(0 TO PeopleCount&)
                               'Contains what event gave the last given speech
DIM SHARED SpeechEventKilled&(0 TO PeopleCount&)
                               'Contains what event took the last taken speech

SUB ConversationChangingEvent (CEvent&)
    DIM RecordHdr AS ConversationBlockType
    DIM RecordEvent AS LONG
    FileSetPos ConverseFileHandle%, 0
    DO
      GET ConverseFileHandle%, , RecordHdr
      SELECT CASE RecordHdr.IDhdr
      CASE "EVST"
        GET ConverseFileHandle%, , RecordEvent
        IF RecordEvent <> CEvent& THEN
          FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + RecordHdr.Length - 4
        END IF
        Size& = (RecordHdr.Length - 4) / 8
        IF Size& <= 0 THEN EXIT SUB'small sanity-type check
        FOR I& = 1 TO Size&
          GET ConverseFileHandle%, , Person&
          GET ConverseFileHandle%, , SpeechPtr&
          Speech&(Person&) = SpeechPtr&
          IF SpeechPtr& = 0 THEN
            SpeechEventKilled&(Person&) = RecordEvent
          ELSE
            SpeechEventStarted&(Person&) = RecordEvent
          END IF
        NEXT I&
      CASE "EVRE"
         GET ConverseFileHandle%, , RecordEvent
         IF RecordEvent <> CEvent& THEN
           FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + RecordHdr.Length - 4
         END IF
        Size& = (RecordHdr.Length - 4) / 12 '12 = LEN(Person&) + LEN(SpeechPtr&) + LEN(OldSpeechPtr&)
        IF Size& <= 0 THEN EXIT SUB'small sanity-type check
        
         FOR I& = 1 TO Size&
           GET ConverseFileHandle%, , Person&
           GET ConverseFileHandle%, , SpeechPtr&
           GET ConverseFileHandle%, , OldSpeechPtr&
           IF Speech&(Person&) = OldSpeechPtr& THEN
             Speech&(Person&) = SpeechPtr&
             IF SpeechPtr& = 0 THEN
               SpeechEventKilled&(Person&) = RecordEvent
             ELSE
               SpeechEventStarted&(Person&) = RecordEvent
             END IF
           END IF
        NEXT I&

      END SELECT
    LOOP UNTIL FileGetPos(ConverseFileHandle%) >= EndOfFile(ConverseFileHandle%)

END SUB

SUB ConverseOpenFile
    'complete
    ConverseFileHandle% = FREEFILE
    OPEN ConverseFileHandle$ FOR BINARY AS ConverseFileHandle%
END SUB

SUB ConverseSetFilename (Filename$)
    ConverseFilename$ = Filename$
END SUB

FUNCTION GetConversation$ (Person&, StringNum&)
    '0 Based
    'This routine is complete, but routines called by this arent
    DIM BlockType AS STRING * 4
    IF Speech&(Person&) = 0 THEN
      GetConversation$ = String0System$(Person&)
    END IF
    FileSetPos ConverseFileHandle%, Speech&(Person&)
   
    BlockType = GetBlockType$
    SELECT CASE BlockType
    CASE "STRN"
      GetConversation$ = STRNgetMulti$(StringNum&)
    CASE "STAR"
      GetConversation$ = STARMultiStringget$(StringNum&)
    CASE ELSE
      GetConversation$ = "My Speech& is pointing to an non-string"
    END SELECT
END FUNCTION

SUB KillSpeech (CEvent&, Person&)
    Speech&(Person&) = 0
    SpeechEventKilled&(Person&) = CEvent&
END SUB

SUB OpenConverse
    ConverseFileHandle% = FREEFILE
    OPEN ConverseFilename$ FOR BINARY AS ConverseFileHandle%

END SUB

FUNCTION String0System$ (Person&)
    String0System$ = "Dead Conversation: Event Killed:" + STR$(SpeechEventKilled&(Person&)) + "Last Activation Event:" + STR$(SpeechEventStarted&(Person&))
END FUNCTION

