DECLARE SUB FileToString (Text$, Filenum%)
DECLARE FUNCTION STRNgetMulti$ (StringNum&)
DECLARE FUNCTION STARMultiStringget$ (StringNum&)
DECLARE FUNCTION GetBlockType$ ()
DEFINT A-Z

'IDhdr="EVNM" 'Block Contains a list of event names
'IDhdr-"PRNM" 'Block Contains a list of Person names
'IDhdr="EVST" Event sets the persons conversation no matter what
'IDhdr="EVRE" Event sets the persons conversation based on previous
'             conversation RE = Replace
'IDhdr="STRN" Block contains strings
'IDhdr="STAR" Block contains pointers to strings
'IDhdr="MEVN" Block contains a multievent equation
'IDhdr=MKL$(0) 'unallocated

TYPE ConversationBlockType
    IDhdr AS STRING * 4
    Length AS LONG
END TYPE



DECLARE SUB FindBlockOfType (BlockType$, Done%)

DECLARE FUNCTION EVNMseek$ (EventNum&)

DECLARE FUNCTION EndOfFile& (FileHandle%)
DECLARE FUNCTION FileBlockSize& ()

DECLARE SUB MoveToNextBlock ()


DECLARE SUB FileSetPos (FileHandle%, fpos&)
DECLARE SUB EVNMput (Cevent&, Text$)
DECLARE FUNCTION TypeOfNextBlock$ ()
DECLARE FUNCTION FileGetPos& (FileHandle%)


COMMON SHARED /ConverseFile/ ConverseFilename$, ConverseFileHandle%

SUB BlockErase
    DIM IDhdr AS STRING * 4
    IDhdr = MKL$(0)
    f& = FileGetPos(ConverseFileHandle%)
    PUT ConverseFileHandle%, , IDhdr
    FileSetPos ConverseFileHandle%, f&
END SUB

SUB EVNMconcat (Cevent&, Text$)
    'Incomplete
    FileSetPos ConverseFileHandle%, 0
    DO
      FindBlockOfType "EVNM", Done%
      CurrEventNameBlock& = FileGetPos(ConverseFileHandle%)
      IF TypeOfNextBlock$ = MKL$(0) THEN
        MoveToNextBlock
        Size& = FileBlockSize&
        IF LEN(Text$) > Size& THEN
        END IF
      END IF
      IF Done% THEN
        FileSetPos ConverseFileHandle%, EndOfFile(ConverseFileHandle%)
        EVNMput Cevent&, Text$
        EXIT DO
      END IF
    LOOP
END SUB

SUB EVNMput (Cevent&, Text$)
    'Done, no position protection
    DIM hdrID AS STRING * 4
    hdrID = "EVNM"
    PUT ConverseFileHandle%, , hdrID
    Size& = LEN(Text$) + 8
    PUT ConverseFileHandle%, , Size&
    PUT ConverseFileHandle%, , Cevent&
    Size& = LEN(Text$)
    PUT ConverseFileHandle%, , Size&
    PUT ConverseFileHandle%, , Text$

END SUB

FUNCTION EVNMseek$ (EventNum&)
    'Incomplete
END FUNCTION

SUB EVSTput (EventNum&, PersonNum&, StringNum&)
    DIM IDhdr AS STRING * 4
    IDhdr = "EVST"'Event Set
    PUT ConverseFileHandle%, , IDhdr
    Size& = 24
    PUT ConverseFileHandle%, , Size&
    PUT ConverseFileHandle%, , EventNum&
    PUT ConverseFileHandle%, , PersonNum&
    PUT ConverseFileHandle%, , StringNum&
END SUB

FUNCTION FileBlockSize&
    DIM Header AS ConversationBlockType
    f& = FileGetPos(ConverseFileHandle%)
    GET ConverseFileHandle%, , Header
    FileSetPos ConverseFileHandle%, f&
END FUNCTION

FUNCTION GetBlockType$
    DIM IDhdr AS STRING * 4
    f& = FileGetPos(ConverseFileHandle%)
    GET ConverseFileHandle%, , IDhdr
    FileSetPos ConverseFileHandle%, f&
    GetBlockType$ = IDhdr
END FUNCTION

SUB MoveToNextBlock
    DIM Header AS ConversationBlockType
    GET ConverseFileHandle%, , Header
    FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + Header.Length
END SUB

FUNCTION STARMultiStringget$ (StringNum&)
    DIM Header AS ConversationBlockType
    GET ConverseFileHandle%, , Header
    IF Header.Length = 0 THEN EXIT FUNCTION
    Count& = StringNum&
    Size& = 0
    DO
      GET ConverseFileHandle%, , StringPtr&
      IF Count& = 0 THEN EXIT DO
      Size& = Size& + 4
      IF Size& >= Header.Length THEN EXIT FUNCTION
      IF FileGetPos(ConverseFileHandle%) >= EndOfFile(ConverseFileHandle%) THEN EXIT FUNCTION
      Count& = Count& - 1
    LOOP
      FileSetPos ConverseFileHandle%, StringPtr&
      GET ConverseFileHandle%, , Header
      IF Header.IDhdr = "STRN" THEN
        FileToString Text$, ConverseFileHandle%
        STARMultiStringget$ = Text$
      ELSE
        STARMultiStringget$ = "My Speech& Points to A STAR that doesn't point to a STRN"
      END IF
END FUNCTION

SUB StringPointerHolders
'Any Time a string changes position all string pointer holders
'need to be scanned for the old position of string and updated
'with the new position
END SUB

FUNCTION STRNgetMulti$ (StringNum&)
    'This funchtion looks done
    DIM Header AS ConversationBlockType
    GET ConverseFileHandle%, , Header
    IF Header.Length = 0 THEN EXIT FUNCTION
    Count& = StringNum&
    Size& = 0
    DO
      GET ConverseFileHandle%, , StringLength&
      Temp$ = SPACE$(StringLength&)
      GET ConverseFileHandle%, , Temp$
      IF Count& = 0 THEN EXIT DO
      Size& = Size& + StringLength& + 4
      IF Size& >= Header.Length THEN EXIT FUNCTION
      IF FileGetPos(ConverseFileHandle%) >= EndOfFile(ConverseFileHandle%) THEN EXIT FUNCTION
      Count& = Count& - 1
    LOOP
    STRNgetMulti$ = Temp$
END FUNCTION

FUNCTION TypeOfNextBlock$
    'File Pointer must be at beginning of a block
    DIM hdrID AS STRING * 4
    DIM Header AS ConversationBlockType
    f& = FileGetPos(ConverseFileHandle%)
    GET ConverseFileHandle%, , Header
    FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + Header.Length
    GET ConverseFileHandle%, , hdrID
    TypeOfNextBlock$ = hdrID
   
    FileSetPos ConverseFileHandle%, f&

END FUNCTION

