DEFINT A-Z
DECLARE FUNCTION ConverseDataEOFBlock$ ()
DECLARE FUNCTION ConverseGetEOFBlock$ ()

DECLARE SUB FindBlockOfType (BlockType$, Done%)

DECLARE FUNCTION FileGetPos& (FileHandle%)
DECLARE FUNCTION EndOfFile& (FileHandle%)

DECLARE FUNCTION FindNextBlank% ()
DECLARE SUB FileSetPos (FileHandle%, fpos&)
DECLARE FUNCTION BlockLen& ()

DECLARE SUB StringToFile (Text$, Filenum%)

TYPE ConversationBlockType
    IDhdr AS STRING * 4
    Length AS LONG
END TYPE
COMMON SHARED /ConverseFile/ ConverseFilename$, ConverseFileHandle%

'Conversation File Management Routines
DIM SHARED FirstBlank AS LONG

FUNCTION BlockLen&
    DIM Temp AS ConversationBlockType
    TempPos& = FileGetPos(ConverseFileHandle%)
    GET 1, , Temp
    FileSetPos ConverseFileHandle%, TempPos&
    BlockLen& = Temp.Length
END FUNCTION

FUNCTION ConverseDataEOFBlock$
    'This routine can be used in a poor man's
    'can I append? routine
    DIM hdrID AS STRING * 4
    hdrID = MKL$(0) 'hdrID would normally be filled with spaces
    DO
      f& = FileGetPos(ConverseFileHandle%)
      GET ConverseFileHandle%, , hdrID
      IF hdrID <> MKL$(0) THEN
        Temp$ = hdrID
      END IF
      GET ConverseFileHandle%, , Size&
      
      FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + Size&
    LOOP UNTIL FileGetPos(ConverseFileHandle%) >= EndOfFile(ConverseFileHandle%)
    ConverseDataGetEOFBlock$ = Temp$
END FUNCTION

FUNCTION ConverseGetEOFBlock$
    'This routine can be used in a poor man's
    'can I append? routine
    DIM hdrID AS STRING * 4
    DO
      f& = FileGetPos(ConverseFileHandle%)
      GET ConverseFileHandle%, , hdrID
      GET ConverseFileHandle%, , Size&
      FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + Size&
    LOOP UNTIL FileGetPos(ConverseFileHandle%) >= EndOfFile(ConverseFileHandle%)
    ConverseGetEOFBlock$ = hdrID
END FUNCTION

SUB FindBlockOfType (BlockType$, Done%)
    DIM hdrID AS STRING * 4
   
    DO
      f& = FileGetPos(ConverseFileHandle%)
      GET ConverseFileHandle%, , hdrID
      IF hdrID = BlockType$ THEN
         FileSetPos ConverseFileHandle%, f&
         EXIT SUB
      ELSE
         GET ConverseFileHandle%, , Size&
         FileSetPos ConverseFileHandle%, FileGetPos(ConverseFileHandle%) + Size&
      END IF
    LOOP UNTIL FileGetPos(ConverseFileHandle%) >= EndOfFile(ConverseFileHandle%)
    'We should only get here if we are at the end of file
    'We can only tell if there are no more blocks of a given type
    'if we are at the end of file, however there are record systems out there
    '(the OBJ format, for example) that have a special record for signaling
    'that there are no more record of a given type past that record
    Done% = -1
END SUB

FUNCTION FindNextBlank%

END FUNCTION

SUB STRNput (Text AS STRING)
    DIM IDhdr AS STRING * 1
    IDhdr = "STRN"
    PUT ConverseFileHandle%, , IDhdr
    Size& = LEN(Text) + 4
    PUT ConverseFileHandle%, , Size&
    StringToFile Text, ConverseFileHandle%
END SUB

